#!/bin/sh
#------------------------------------------------------------------------------
# actions.cgi - Change dialmode and default-circuit, etc.
#
# Creation:     03.02.2001  tg
# Last Update:  $Id: actions.cgi,v 1.4 2001/11/02 15:59:41 tobig Exp $
#
#------------------------------------------------------------------------------

DTIME=20
ATIME=1

bt='bgcolor="#FFFFFF" text="#000000" link="#FFFF66" vlink="#FFFF00" alink="#FFFF00"'

myname=`basename $0`

SEC_REALM='status'
SEC_ACTION='view'

case "$QUERY_STRING" in
  reboot*|halt*)
    SEC_ACTION='boot'
    RTIME="1000"
    ;;
  dialmode*)
    SEC_ACTION='dialmode'
    RTIME="$ATIME"
    ;;
  circuit*)
    SEC_ACTION='circuit'
    RTIME="$ATIME"
    ;;
  "")
    RTIME="$DTIME"
    ;;
  *)
    RTIME="$ATIME"
    ;;
esac

. sec-lib.cgi

echo "Content-Type: text/html; charset=iso-8859-1"
echo "Cache-control: no-store" # HTTP/1.1 (or no-cache?)
echo "Pragma: no-cache"        # HTTP/1.0
echo "Expires: `date -Ru`"     # Expires now!
echo "Refresh: $RTIME; URL=$myname"
echo
echo "<html><head>"
echo "<LINK REL=STYLESHEET TYPE=\"text/css\" HREF=\"main.css\">"
# special CSS
echo '<style type="text/css"><!--'
echo 'body    { font-size: 10pt }'
echo 'a { text-decoration: none }'
echo 'a:hover { color: #00FF00 }'
echo '--></style>'
echo "<meta HTTP-EQUIV=\"Refresh\" CONTENT=\"$RTIME;url=$myname\">"

# Check for installed packages
if [ ! -f /var/run/imond.port ]
then
  echo "<title>Error</title></head><body $bt>"
  echo "<h1>An error occured!</h1>"
  echo "<p>Check if you have installed IMOND (START_IMOND)!"
  echo "</body></html>"
  exit 1
fi

port=`cat /var/run/imond.port`

if [ "$QUERY_STRING" != "" ]
then
  part1=`echo "$QUERY_STRING" | cut -f 1 -d"="`
  part2=`echo "$QUERY_STRING" | cut -f 2 -d"="`

  case "$part1"
  in
  circuit)
    echo "<title>Change Circuit to $part2</title></head><body $bt>"
    echo "<h1>Changing Circuit to $part2...</h1><pre>"
    { echo "route $part2" ; echo "quit"; } | netcat localhost $port
    echo "</pre></body></html>"
  ;;
  dialmode)
    echo "<title>Change Dialmode to \"$part2\"</title></head><body $bt>"
    echo "<h1>Changing Dialmode to \"$part2\"...</h1><pre>"
    { echo "dialmode $part2" ; echo "quit"; } | netcat localhost $port
    echo "</pre></body></html>"
  ;;
  reboot)
    echo "<title>Reboot</title></head><body $bt>"
    echo "<h1>Rebooting...</h1><pre>"
    { echo "reboot" ; echo "quit"; } | netcat localhost $port
    echo "</pre></body></html>"
  ;;
  halt)
    echo "<title>Halt</title></head><body $bt>"
    echo "<h1>Halting system...</h1><pre>"
    { echo "halt" ; echo "quit"; } | netcat localhost $port
    echo "</pre></body></html>"
  ;;
  esac
  exit 1
fi

circuits=`{ echo "circuits" ; echo "quit"; } | netcat localhost $port |
  sed 's/.$//; s/OK //'`
comm=''
i=1
while [ $i -le $circuits ]
do
  comm=`if [ "$comm" != "" ]; then echo "$comm"; fi; echo "circuit $i"`
  i=`expr $i + 1`
done
circuits=`{ echo "$comm"; echo "quit"; } | netcat localhost $port |
  grep -n 'OK' | sed 's/^/<tr><td width="10">\&nbsp;<\/td><td><a href="'$myname'?circuit=/; s/:OK /">/;
  s/.$/<\/a><\/td><\/tr>/'`
circuits="<tr><td width="10">&nbsp;</td><td><a href=\"$myname?circuit=0\">Automatic (LCR)</a></td></tr>
$circuits"
aktcirc=`{ echo "route"; echo "quit"; } | netcat localhost $port | sed 's/OK //; s/.$//')`
circuits=`echo "$circuits" | sed '/circuit='$aktcirc'/ s/<td/<td id="selected" bgcolor="#009900"/'`

dialmode="<tr><td width="10">&nbsp;</td><td><a href=\"$myname?dialmode=auto\">Auto</a></td></tr>
  <tr><td width="10">&nbsp;</td><td><a href=\"$myname?dialmode=manual\">Manual</a></td></tr>
  <tr><td width="10">&nbsp;</td><td><a href=\"$myname?dialmode=off\">Off</a></td></tr>"
aktdialm=`{ echo "dialmode"; echo "quit"; } | netcat localhost $port | sed 's/OK //; s/.$//')`
dialmode=`echo "$dialmode" | sed '/dialmode='$aktdialm'/ s/<td/<td id="selected" bgcolor="#009900"/'`

echo "<title>Actions</title></head><body $bt"
echo 'topmargin="0" leftmargin="0" marginwidth="0" marginheight="0">'
echo '<table width="100%" height="100%"><tr><td>'

echo '<p align=center><table width="500" align=center>'
echo '<tr><td bgcolor="#666666"><font color="#FFFFFF"><b>Circuits:</b></font></td>'
echo '<td bgcolor="#666666" width="25%"><font color="#FFFFFF">'
echo '<b>Dialmode:</b></font></td><td bgcolor="#666666" width="30%">'
echo '<font color="#FFFFFF"><b>System commands:</b></font></td>'
echo '</tr><tr><td bgcolor="#808080" align="center" rowspan=2>'
echo '<table width="80%" cellspacing="1" cellpadding="0">'
echo "$circuits"
echo '</table></td><td bgcolor="#808080" align="center" rowspan=2>'
echo '<table width="80%" cellspacing="1" cellpadding="0">'
echo "$dialmode"
echo '</table></td><form method="GET"><td align="center" bgcolor="#808080">'
echo '<input type="submit" value="Reboot" name="reboot" style="font-size: 8pt">'
echo '</td></form></tr>'
echo '<tr><form method="GET"><td align="center" bgcolor="#808080">'
echo '<input type="submit" value="Halt" name="halt" style="font-size: 8pt">'
echo '</td></form></tr></table></p>'

echo '</td></tr></table></body></html>'

exit 0