#!/bin/sh
#------------------------------------------------------------------------------
# calls.cgi - show calls loged by telmond
#
# Creation:     03.02.2001  tg
# Last Update:  $Id: calls.cgi,v 1.5 2001/10/20 07:49:56 ukw Exp $
#
#------------------------------------------------------------------------------

SEC_REALM='logs'

if [ "$QUERY_STRING" = "reset" ]
then
  SEC_ACTION='reset'
else
  SEC_ACTION='view'
fi

. sec-lib.cgi

echo "Content-Type: text/html; charset=iso-8859-1"
echo "Cache-control: no-store" # HTTP/1.1 (or no-cache?)
echo "Pragma: no-cache"        # HTTP/1.0
echo "Expires: `date -Ru`"     # Expires now!

# Check for installed packages
if [ ! -f /var/run/imond.port ]
then
  echo
  echo "<html><head><title>Error</title></head><body>"
  echo "<h1>An error occured!</h1>"
  echo "<p>Check if you have installed IMOND (START_IMOND)"
  echo "and TELMOND (OPT_TELMOND)!"
  echo "</body></html>"
  exit 1
fi

ATIME=1
myname=`basename $0`
tmp="/tmp/$myname.$$"
port=`cat /var/run/imond.port`

if [ "$QUERY_STRING" = "reset" ]
then
  echo "Refresh: $ATIME; URL=$myname"
  echo
  echo '<html><head><title>Reset the logfile</title>'
  echo "<meta HTTP-EQUIV=\"Refresh\" CONTENT=\"$ATIME;url=$myname\">"
  echo '</head><body bgcolor="#FFFFFF" text="#000000">'
  echo '<h1>Resetting the TELMOND-Logfile...</h1><pre>'
  (echo "reset-telmond-log-file"; echo "quit") | netcat localhost $port
  echo '</pre></body></html>'
  exit 1
fi

echo
echo '<html><head>'
echo '<LINK REL=STYLESHEET TYPE="text/css" HREF="main.css">'
echo '<title>TELMOND-Logfile</title>'
echo '</head><body bgcolor="#FFFFFF" text="#000000">'

{ echo "telmond-log-file" ; echo "quit"; } | netcat localhost $port |
  sed 's/.$//' > $tmp.1

sed 's/^ /<tr><td>/
  s/$/<\/td><\/tr>/
  s/ \+/<\/td><td>/g
  $ d' $tmp.1 > $tmp.2

# Use phonebook
sed '/^#/d; /^[^=]*$/d; s/^/s|>/; s/=/<|>/; s/,[^,]*$//; s/$/<|g/' /etc/phonebook > $tmp.3
sed -f $tmp.3 $tmp.2> $tmp.1

echo "<table border=\"1\" cellpadding=\"2\">"
echo "<tr><th>Date</th><th>Time</th><th>Calling Number</th><th>Called Number</th></tr>"

rcat $tmp.1

echo "</table>"
echo "<p><a href=\"$myname?reset\">Reset</a>"
echo "</body></html>"

rm $tmp.?

exit 0
