#!/bin/sh
#------------------------------------------------------------------------------
# connections.cgi - show connections to the internet
#
# Creation:     03.02.2001  tg
# Last Update:  $Id: connections.cgi,v 1.5 2001/10/20 07:49:56 ukw Exp $
#
#------------------------------------------------------------------------------

SEC_REALM='logs'

if [ "$QUERY_STRING" = "reset" ]
then
  SEC_ACTION='reset'
else
  SEC_ACTION='view'
fi

. sec-lib.cgi

echo "Content-Type: text/html; charset=iso-8859-1"
echo "Cache-control: no-store" # HTTP/1.1 (or no-cache?)
echo "Pragma: no-cache"        # HTTP/1.0
echo "Expires: `date -Ru`"     # Expires now!

# Check for installed packages
if [ ! -f /var/run/imond.port ]
then
  echo
  echo "<html><head><title>Error</title></head><body>"
  echo "<h1>An error occured!</h1>"
  echo "<p>Check if you have installed IMOND (START_IMOND)!"
  echo "</body></html>"
  exit 1
fi

ATIME=1
myname=`basename $0`
tmp="/tmp/$myname.$$"
port=`cat /var/run/imond.port`

if [ "$QUERY_STRING" = "reset" ]
then
  echo "Refresh: $ATIME; URL=$myname"
  echo
  echo '<html><head><title>Reset the logfile</title>'
  echo "<meta HTTP-EQUIV=\"Refresh\" CONTENT=\"$ATIME;url=$myname\">"
  echo '</head><body bgcolor="#FFFFFF" text="#000000">'
  echo '<h1>Resetting the IMOND-Logfile...</h1><pre>'
  { echo "reset-imond-log-file"; echo "quit"; } | netcat localhost $port
  echo '</pre></body></html>'
  exit 1
fi

echo
echo '<html><head>'
echo '<LINK REL=STYLESHEET TYPE="text/css" HREF="main.css">'
echo '<title>IMOND-Logfile</title>'
echo '</head><body bgcolor="#FFFFFF" text="#000000">'

{ echo "imond-log-file" ; echo "quit"; } | netcat localhost $port |
  sed 's/.$//' > $tmp

sed 's/^ /<tr><td>/
  s/$/<\/td><\/tr>/
  s/ \+/<\/td><td>/g
  $ d' $tmp > $tmp.1

echo '<table border="1" cellpadding="2">'
echo '<tr><th>Circuit</th><th>StartDate</th><th>StartTime</th><th>EndDate</th>'
echo '<th>EndTime</th><th>OnlTime</th><th>ChTime</th><th>Charge</th>'
echo '<th>IBytes</th><th>OBytes</th><th>Device</th><th>ChInt</th>'
echo '<th>ChMin</th></tr>'

rcat $tmp.1

echo '</table>'
echo "<p><a href=\"$myname?reset\">Reset</a>"
echo '</body></html>'

rm $tmp $tmp.1

exit 0
