#!/bin/sh
#------------------------------------------------------------------------------
# menu.cgi - integrate user-defined commands into the menu
# User-Files should start with list_ or main_ to be integrated in this menu!
#
# Info: The shell has problems with ' and \'
#
# Creation:     22.02.2001  tg
# Last Update:  $Id: menu.cgi,v 1.4 2001/10/10 21:40:28 tobig Exp $
#
#------------------------------------------------------------------------------

# Parse variables...
eval "`proccgi $*`"

if [ "$FORM_drop" != "" ]
then
  if [ $SERVER_PORT != 80 ]
  then
    port=":$SERVER_PORT"
  fi
  echo "Location: http://$SERVER_NAME$port/$FORM_drop" # Maybe more?
  echo
  exit 1
fi

echo "Content-Type: text/html; charset=iso-8859-1"
echo "Cache-control: no-store" # HTTP/1.1 (or no-cache?)
echo "Pragma: no-cache"        # HTTP/1.0
echo "Expires: `date -Ru`"     # Expires now!
echo

echo '<html><head>'
echo '<title>FLI4L-Webserver - Menu</title>'
echo '<LINK REL=STYLESHEET TYPE="text/css" HREF="main.css">'
# special CSS
echo '<style type="text/css"><!--'
echo 'body { font-size: 10pt }'
echo 'a { text-decoration: none }'
echo 'a:hover { color: #00FF00 }'
echo '--></style>'
echo '</head>'
echo '<body topmargin="0" leftmargin="0" marginwidth="0" marginheight="0"'
echo ' bgcolor="#000000" text="#FFFFFF" link="#FFFF66" vlink="#FFFF00"'
echo ' alink="#FFFF00">'
echo '<br>'

# Add files to menu starting with list_
listcgi=`echo list_*`
if [ "$listcgi" != 'list_*' ]
then
  echo '<td valign="top" align="right"><form name="form1" target="content">'
  echo "<select size=\"1\" name=\"drop\" onChange=\"if (this[this.selectedIndex].value!='dummy') this.form.submit()\">"
  echo '<option value="dummy" selected>User CGIs</option>'
  echo '<option value="dummy">-----------</option>'
  for j in $listcgi
  do
    echo "<option value=\"$j\">-&gt; "
    echo $j | cut -f1 -d'.' | cut -d_ -f2
    echo '</option>'
  done
  echo '</select><noscript><input type="submit" value="go!"></noscript>'
  echo '</form></td>'
fi

# standard cmd's
echo '<table border="0" width="100%" cellspacing="1">'
echo '<tr><td bgcolor="#666666"><p align="right"><b>Main</b></td></tr>'
echo '<tr><td bgcolor="#808080"><a href="summary.htm" target="content">Summary</a></td></tr>'
echo '<tr><td bgcolor="#808080"><a href="calls.cgi" target="content">Calls</a></td></tr>'
echo '<tr><td bgcolor="#808080"><a href="connections.cgi" target="content">Connections</a></td></tr>'
echo '<tr><td bgcolor="#808080"><a href="timetable.cgi" target="content">Timetable</a></td></tr>'

syslogdest=`grep "\*.\*" /etc/syslog.conf 2> /dev/null | cut -d" " -f2`
if [ -f "$syslogdest" ]
then
  echo '<tr><td bgcolor="#808080"><a href="syslog.cgi" target="content">Syslog</a></td></tr>'
fi

echo '<tr><td bgcolor="#808080"><a href="support.cgi" target="content">Support</a></td></tr>'
echo '</table><br>'

maincgi=`echo main_*`
if [ "$maincgi" != 'main_*' ]
then
  echo '<table border="0" width="100%" cellspacing="1">'
  echo '<tr><td bgcolor="#666666"><p align="right"><b>OPT</b></td></tr>'
  for j in $maincgi
  do
    echo "<tr><td bgcolor=\"#808080\"><a href=\"$j\" target=\"content\">"
    echo $j | cut -f1 -d'.' | cut -d_ -f2
    echo "</a></td></tr>"
  done
  echo '</table>'
fi
echo '</body></html>'

exit 0