#!/bin/sh
#------------------------------------------------------------------------------
# status.cgi - Display Status of ISDN & DSL
#
# Creation:     17.01.2001  tg
# Last Update:  $Id: status.cgi,v 1.3 2001/10/10 21:40:28 tobig Exp $
#
#------------------------------------------------------------------------------

DTIME=5
ATIME=2

bt='bgcolor="#FFFFFF" text="#000000"'

myname=`basename $0`

SEC_REALM='status'
SEC_ACTION='view'

if [ "$QUERY_STRING" = "" ]
then
  RTIME="$DTIME"
else
  RTIME="$ATIME"
  case "$QUERY_STRING" in
    dial*|hangup*) SEC_ACTION='dial' ;;
    addlink*|removelink*) SEC_ACTION='link' ;;
  esac
fi

. sec-lib.cgi

echo "Content-Type: text/html; charset=iso-8859-1"
echo "Cache-control: no-store" # HTTP/1.1 (or no-cache?)
echo "Pragma: no-cache"        # HTTP/1.0
echo "Expires: `date -Ru`"     # Expires now!
echo "Refresh: $RTIME; URL=$myname"
echo
echo "<html><head>"
echo "<meta HTTP-EQUIV=\"Refresh\" CONTENT=\"$RTIME;url=$myname\">"
echo "<LINK REL=STYLESHEET TYPE=\"text/css\" HREF=\"main.css\">"

# Check for installed packages
if [ ! -f /var/run/imond.port ]
then
  echo
  echo "<title>Error</title></head><body $bt>"
  echo "<h1>An error occured!</h1>"
  echo "<p>Check if you have installed IMOND (START_IMOND)!"
  echo "</body></html>"
  exit 1
fi

port=`cat /var/run/imond.port`

if [ "$QUERY_STRING" != "" ]
then
  case "$QUERY_STRING"
  in
  hangup*)
    echo "<title>Hangup</title></head><body $bt>"
    echo "<h1>Hanging up...</h1><pre>"
    { echo "hangup"; echo "quit"; } | netcat localhost $port
    echo "</pre></body></html>"
  ;;
  dial*)
    echo "<title>Dial</title></head><body $bt>"
    echo "<h1>Dialing...</h1><pre>"
    { echo "dial"; echo "quit"; } | netcat localhost $port
    echo "</pre></body></html>"
  ;;
  addlink*)
    echo "<title>Add link</title></head><body $bt>"
    echo "<h1>Adding link...</h1><pre>"
    route=`{ echo "route"; echo "quit"; } | netcat localhost $port |
      sed 's/OK //; s/.$//'`
    { echo "addlink $route"; echo "quit"; } | netcat localhost $port
    echo "</pre></body></html>"
  ;;
  removelink*)
    echo "<title>Remove link</title></head><body $bt>"
    echo "<h1>Removing link...</h1><pre>"
    route=`{ echo "route"; echo "quit"; } | netcat localhost $port |
      sed 's/OK //; s/.$//'`
    { echo "removelink $route"; echo "quit"; } | netcat localhost $port
    echo "</pre></body></html>"
  ;;
  esac
  exit 1
fi

chan=`{ echo "channels"; echo "pppoe"; echo "cpu"; echo "quit"; } | netcat localhost $port |
  sed 's/OK //; s/.$//'`
pppoe=`echo "$chan" | sed -n '2p'`
usage=`echo "$chan" | sed -n '3p'`
chan=`echo "$chan" | sed -n '1p'`

echo '<title>Online-Status</title>'
echo "</head><body $bt><p align=\"center\">"
echo '<table border=0 width="95%" cellspacing="0" cellpadding="0" bgcolor="#C0C0C0"'
echo "align=center><td align=left><b>`date -R`</b></td>"
echo "<td align=right><table border=0 cellspacing=0><tr><td>CPU-Usage: $usage% </td>"
if [ $usage -ne 0 ]
then
  echo "<td width=$usage bgcolor=red>&nbsp;</td>"
fi
if [ $usage -ne 100 ]
then
  echo "<td width=`expr 100 - $usage` bgcolor=green>&nbsp;</td>"
fi
echo '</tr></table></td></table></p>'
echo '<p align=center><table border=0 align=center cellspacing="1">'
echo '<tr bgcolor="#C0C0C0"><th>Connection</th><th>Direction</th><th>IP</th>'
echo '<th>OnlTime</th><th>IRate</th><th>ORate</th><th>IBytes</th><th>OBytes</th>'
echo '<th>Time</th><th>ChTime</th><th>Charge</th></tr>'

onl=0
devs=''
i=1
while [ $i -le $chan ]
do
  devs="$devs $i"
  i=`expr $i + 1`
done

if [ "$pppoe" = "1" ]
then
  devs="$devs pppoe"
fi

for i in $devs
do
  case `{ echo "status $i"; echo "quit"; } | netcat localhost $port |
    sed 's/OK //; s/.$//'`
  in
    Off*)
    id="offline"
    col="FF6666"
    text1="<td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td>
      <td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td>"
    comm=""
    ;;
    Call*)
    id="calling"
    col="FFFF00"
    con=`{ echo "phone $i"; echo "quit"; } | netcat localhost $port |
        sed 's/OK //; s/.$//'`
    text1="<td>$con</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td>
      <td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td>"
    comm=""
    ;;
    On*)
    id="online"
    col="00FF00"
    onl=1
    text1=""
    comm=`echo "phone $i"; echo "inout $i"; echo "ip $i"
      echo "online-time $i"; echo "rate $i"; echo "quantity $i"`
    ;;
  esac
  comm=`if [ "$comm" != "" ]; then echo "$comm"; fi
        echo "time $i"; echo "chargetime $i"; echo "charge $i"`
  text2=`{ echo "$comm"; echo "quit"; } | netcat localhost $port |
         sed 's/OK //; s/^/<td>/; s/.$/<\/td>/; 5,6 s/ /<\/td><td>/'`
  echo "<tr id=\"$id\" bgcolor=\"#$col\">$text1$text2</tr>"
done

echo "</table>"

# Check for channel-bundling
route=`{ echo "route"; echo "quit"; } | netcat localhost $port |
  sed 's/OK //; s/.$//'`
links=`{ echo "links $route"; echo "quit"; } | netcat localhost $port |
  sed 's/OK //; s/.$//'`

if [ $links -eq 0 ]
then
  cols=1
else
  cols=2
fi

# Check if telmond is running
TELMOND_PORT=`ps ax | grep telmond | grep -v grep |
  sed -n 's/^[^!]*-port \([^ ]*\)[^!]*/\1/p`
if [ "$TELMOND_PORT" != "" ]
then
  LASTCALL=`netcat localhost $TELMOND_PORT 2>/dev/null | sed 's/.$//'`

  if [ "$LASTCALL" != "" ]
  then
    LASTTIME=`echo $LASTCALL | cut -f 1-2 -d" "`
    LASTFROM=`echo $LASTCALL | cut -f 3 -d" "`
    LASTTO=`echo $LASTCALL | cut -f 4 -d" "`

    # Find names in phonebook
    NAME=`grep "^$LASTFROM=" /etc/phonebook | cut -d"=" -f 2- | cut -d"," -f 1`
    if [ "$NAME" != "" ]; then LASTFROM="$NAME"; fi
    NAME=`grep "^$LASTTO=" /etc/phonebook | cut -d"=" -f 2- | cut -d"," -f 1`
    if [ "$NAME" != "" ]; then LASTTO="$NAME"; fi
  fi
fi

echo '<p align=center><table border="0" align="center" cellspacing="1" cellpadding="2">'
echo '<tr><td colspan="'$cols'" bgcolor="#666666"><b><font color="#FFFFFF">'
echo 'Actions:</font></b></td>'

if [ "$LASTCALL" != "" ]
then
  echo '<td rowspan=2 bgcolor="#000000">&nbsp;</td>'
  echo '<th rowspan=2 bgcolor="#666666">Last call:</th>'
  echo '<th bgcolor="#666666">From</th><th bgcolor="#666666">To</th>'
  echo '<th bgcolor="#666666">Time</td>'
fi

echo '</tr><tr align=center><form method="GET"><td width="50" bgcolor="#808080">'
echo '<p align="center"><input type="submit"'

if [ "$onl" -eq 1 ]
then
  echo 'value="Hangup" name="hangup"'
else
  echo 'value="Dial" name="dial"'
fi

echo 'style="font-size: 8pt"></td></form>'

# Channel-Bundling?
if [ $links -ne 0 ]
then
  echo '<form method="GET"><td width="50" bgcolor="#808080">'
  echo '<p align="center"><input type="submit"'
  case "$links"
  in
    1) echo 'value="Add Link" name="addlink"' ;;
    2) echo 'value="Remove Link" name="removelink"' ;;
  esac
  echo 'style="font-size: 8pt"></td></form>'
fi

if [ "$LASTCALL" != "" ]
then
  echo "<td bgcolor=\"#808080\">$LASTFROM</td><td bgcolor=\"#808080\">$LASTTO</td>"
  echo "<td bgcolor=\"#808080\">$LASTTIME</td>"
fi

echo "</tr></table>"
echo "</body></html>"

exit 0