#!/bin/sh
#------------------------------------------------------------------------------
# timetable.cgi - shows the circuit timetable in colorful format
#
# Creation:     20.01.2001  tg
# Last Update:  $Id: timetable.cgi,v 1.3 2001/10/10 21:40:28 tobig Exp $
#
#------------------------------------------------------------------------------

SEC_REALM='misc'
SEC_ACTION='timetable'

. sec-lib.cgi

echo "Content-Type: text/html; charset=iso-8859-1"
echo "Cache-control: no-store" # HTTP/1.1 (or no-cache?)
echo "Pragma: no-cache"        # HTTP/1.0
echo "Expires: `date -Ru`"     # Expires now!
echo

# Check for installed packages
if [ ! -f /var/run/imond.port ]
then
  echo "<html><head><title>Error</title></head><body>"
  echo "<h1>An error occured!</h1>"
  echo "<p>Check if you have installed IMOND (START_IMOND)!"
  echo "</body></html>"
  exit 1
fi

echo '<html><head>'
echo '<title>Circuits</title>'
echo '<LINK REL=STYLESHEET TYPE="text/css" HREF="main.css">'
echo '</head><body bgcolor="#FFFFFF" text="#000000">'

myname=`basename $0`
port=`cat /var/run/imond.port`

if [ 0$QUERY_STRING -gt 0 ]
then
  num=" $QUERY_STRING"
  addtext="<p><a href=\"$myname\">Back to general timetable...</a>"
else
  num=""
  addtext=""
fi

table=`{ echo "timetable$num" ; echo "quit"; } | netcat localhost $port
# | sed '1,10 s/.$//'`

table1=`echo "$table" | sed -n '1,9 p'`
table2=`echo "$table" | sed -n '11,$ p'`
unset table

table1=`echo "$table1" | sed '
  1 s/ \{1,5\}/<\/th><th width="20">/g
  2d
  3,$ s/ \{1,2\}\([0123456789]\{1,2\}\)/<\/td><td id="circuit\1">\1/g
  s/^ \?/<tr><td>/
  s/$/<\/td><\/tr>/
  1 s/<\/td>/<\/th>/
  1 s/<td>/<th width="25">/'`

table2=`echo "$table2" | sed '
  1 s/^ \?/<tr><td>/
  2,$ s/^ \{1,2\}\([0123456789]\{1,2\}\)/<tr id="circuit\1"><td><a href="'$myname'?\1">\1<\/a>/
  s/ \{2,\}/<\/td><td>/g
  s/$/<\/td><\/tr>/
  $d '`

echo '<table border="1" cellpadding="2">'
echo "$table1"
echo '</table><p><table border="1" cellpadding="2">'
echo "$table2"
echo '</table>'
echo "$addtext</body></html>"

exit 0